//(c)Dharma Shukla(dharmashukla@hotmail.com)
// FinderControl.cpp : Implementation of CFinderControl
#include "stdafx.h"
#include "FinderProj.h"
#include "FinderControl.h"


// CFinderControl
//---------------------------------------------------------------------------------------------------------
HRESULT CFinderControl::SetToolTipProperty(IDispatch *pDispatch, LPTSTR pszTT)
{
	if(!pDispatch) { return E_POINTER; }
	
	CComBSTR strTT(pszTT);
	CComVariant var(strTT);
	CComDispatchDriver disp(pDispatch);
	HRESULT hr = disp.PutPropertyByName(L"ToolTipText",&var);
	
	return hr;
}
//---------------------------------------------------------------------------------------------------------
HRESULT CFinderControl::SetControlDataList(IOleClientSite *pClientSite)
{
	if(!pClientSite){ return E_POINTER;	}

	CComPtr<IOleContainer>	spOleContainer;
	HRESULT hr = pClientSite->GetContainer(&spOleContainer);
	if(FAILED(hr)) { return hr;	}

	CComPtr<IEnumUnknown>	spEnumUnk;
	hr = spOleContainer->EnumObjects(OLECONTF_EMBEDDINGS |OLECONTF_OTHERS,&spEnumUnk);
	if(FAILED(hr)) {  return hr; }

	CComPtr<IUnknown>	spUnk;
			
	while (spEnumUnk->Next(1,&spUnk,NULL) == S_OK) 
	{
		CComPtr<IOleObject> spOleObject;
		hr = spUnk->QueryInterface(IID_IOleObject,(void**)&spOleObject);
			  
		CControlData data;	

		if(SUCCEEDED(hr)) 
		{
			//ActiveX control
			CComPtr<IOleClientSite> spClientSite;

			if(SUCCEEDED(spOleObject->GetClientSite(&spClientSite)))
			{
				CComQIPtr<IOleInPlaceSite> spInPlaceSite(spClientSite);
				if(spInPlaceSite)
				{
					
					CComPtr<IDispatch> spExtendedDispatch;	
					CComQIPtr<IOleControlSite,&IID_IOleControlSite> spControlSite(spClientSite);

					if(spControlSite && SUCCEEDED(spControlSite->GetExtendedControl(&spExtendedDispatch)))
					{
						//Get all its supported interfaces and store it in m_pszToolTip
						EnumerateInterfaces(spUnk);
						
						//Set the extended property ToolTipText to our TT string
						SetToolTipProperty(spExtendedDispatch, m_pszToolTip);

						data.m_strToolTipText = m_pszToolTip;
						data.m_spUnknown = spUnk;	
						m_vecData.insert(m_vecData.end(),data);
					}
				}
			}
		}
		else//VB Control
		{
			CComPtr<IDispatch> spDispVBControl;	
			hr = spUnk->QueryInterface(IID_IDispatch,(void**)&spDispVBControl);

			if(SUCCEEDED(hr))
			{
				//Get all its supported interfaces and store it in m_pszToolTip
				EnumerateInterfaces(spUnk);
				
				//Set the extended property ToolTipText to our TT string
				SetToolTipProperty(spDispVBControl, m_pszToolTip);

				data.m_strToolTipText = m_pszToolTip;
				data.m_spUnknown = spUnk;	
				
				m_vecData.insert(m_vecData.end(),data);
			}
		}
			
		spUnk.Release();
	}
	
	return S_OK;
}
//---------------------------------------------------------------------------------------------------------
//Only the ones that are registered of course
HRESULT CFinderControl::EnumerateInterfaces(IUnknown *pUnk)
{
	if(!pUnk){ return E_POINTER; }

	HKEY hk  = 0;
	
	TCHAR szIID[80] ;
	TCHAR szValue[256] ;

	IID  iid = GUID_NULL;
	lstrcpy(m_pszToolTip,_T(""));	

	if (::RegOpenKey( HKEY_CLASSES_ROOT, _T("Interface"), &hk) == ERROR_SUCCESS)
	{
		for (DWORD dwIndex = 0 ;RegEnumKey( hk, dwIndex, szIID, sizeof(szIID)) == ERROR_SUCCESS ;++dwIndex )
		{
			LONG cb = sizeof(szValue);
			if (::RegQueryValue(hk,(LPTSTR)szIID, szValue, &cb) == ERROR_SUCCESS)
			{
				USES_CONVERSION;
				::CLSIDFromString(T2OLE(szIID),&iid) ;
				CComPtr<IUnknown> spFoo;

				if (SUCCEEDED(pUnk->QueryInterface(iid,(void**)&spFoo)))
				{
					//Supported Interface . pfoo is the pointer to the supported interface
					lstrcat(szValue,_T("\n"));
					lstrcat(m_pszToolTip,szValue);
					
					ATLTRACE("\n");
					ATLTRACE(szValue); //Name
					ATLTRACE("\n");
					ATLTRACE(szIID); //IID
					
					spFoo.Release() ;
				}
			}
		}
		::RegCloseKey(hk) ; hk=0;
	}

	return S_OK;
}
//---------------------------------------------------------------------------------------------------------
STDMETHODIMP CFinderControl::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IFinderControl,
	};
	for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i], riid))
			return S_OK;
	}
	return S_FALSE;
}

//---------------------------------------------------------------------------------------------------------
HRESULT CFinderControl::OnDraw(ATL_DRAWINFO& di)
{
	RECT& rc = *(RECT*)di.prcBounds;
	Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);

	SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);
	LPCTSTR pszText = _T("ATL 3.0 : FinderControl");
	TextOut(di.hdcDraw, 
		(rc.left + rc.right) / 2, 
		(rc.top + rc.bottom) / 2, 
		pszText, 
		lstrlen(pszText));

	return S_OK;
}
//---------------------------------------------------------------------------------------------------------
STDMETHODIMP CFinderControl::ShowToolTips()
{
	if(!m_spClientSite){ return E_FAIL; }

	HCURSOR hCur = ::SetCursor(LoadCursor(NULL,IDC_WAIT));
	
	HRESULT hr = SetControlDataList(m_spClientSite);
	
	::SetCursor(hCur);
	
	return hr;
}
//---------------------------------------------------------------------------------------------------------
