//(c)Dharma Shukla(dharmashukla@hotmail.com)
// FinderControl.h : Declaration of the CFinderControl
#pragma once
#ifndef __FINDERCONTROL_H_
#define __FINDERCONTROL_H_

#include "resource.h"       // main symbols
#include "commctrl.h"
#include <atlctl.h>
#include <vector>
using namespace std;

//---------------------------------------------------------------------------------------------------------
struct CControlData
{
	CComPtr<IUnknown>	m_spUnknown;
	CComBSTR			m_strToolTipText;
};

// CFinderControl
class ATL_NO_VTABLE CFinderControl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IFinderControl, &IID_IFinderControl, &LIBID_FINDERPROJLib>,
	public CComControl<CFinderControl>,
	public IPersistStreamInitImpl<CFinderControl>,
	public IOleControlImpl<CFinderControl>,
	public IOleObjectImpl<CFinderControl>,
	public IOleInPlaceActiveObjectImpl<CFinderControl>,
	public IViewObjectExImpl<CFinderControl>,
	public IOleInPlaceObjectWindowlessImpl<CFinderControl>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CFinderControl>,
	public IPersistStorageImpl<CFinderControl>,
	public ISpecifyPropertyPagesImpl<CFinderControl>,
	public IQuickActivateImpl<CFinderControl>,
	public IDataObjectImpl<CFinderControl>,
	public IProvideClassInfo2Impl<&CLSID_FinderControl, &DIID__IFinderControlEvents, &LIBID_FINDERPROJLib>,
	public IPropertyNotifySinkCP<CFinderControl>,
	public CComCoClass<CFinderControl, &CLSID_FinderControl>
{

public:
	CFinderControl() {	m_bWindowOnly = TRUE; 	}

DECLARE_REGISTRY_RESOURCEID(IDR_FINDERCONTROL)
DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CFinderControl)
	COM_INTERFACE_ENTRY(IFinderControl)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(CFinderControl)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(CFinderControl)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CFinderControl)
	CHAIN_MSG_MAP(CComControl<CFinderControl>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()

	HRESULT SetControlDataList(IOleClientSite *pClientSite);
	HRESULT EnumerateInterfaces(IUnknown *pUnk);
	HRESULT SetToolTipProperty(IDispatch *pExtDispatch, LPTSTR pszTT);
	
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

public:

	HRESULT OnDraw(ATL_DRAWINFO& di);
	
public:
	STDMETHOD(ShowToolTips)();
	std::vector<CControlData>	m_vecData;
	TCHAR						m_pszToolTip[5120];			
};

typedef std::vector<CControlData>::iterator itControlData;


#endif //__FINDERCONTROL_H_
